<?php

if (@file_exists('inc/auth.inc.php') && @include_once 'inc/auth.inc.php');
else exit;

require_once 'db-core/db-core.inc.php';

$ezin_admin_bindings_triggers = array( /* {{{ */
		'before' => 'inc-db/triggers/bindings.before',
		'after'  => 'inc-db/triggers/bindings.after',
		); /* }}} */

/*
 * ezin_admin_bindings_main()
 */

function ezin_admin_bindings_main($perm_articles, $perm_sections) /* {{{ */
{
	global $ezin_sys;
	global $ezin_cfg;
	global $ezin_db_handle;

	$op_list = array(
			'article_bind_theme' => strstr($perm_articles, 'a'),
			'article_bind_lang'  => strstr($perm_articles, 'a'),
			'page_bind_lang'     => strstr($perm_articles, 'a'),
			'section_bind_lang'  => strstr($perm_sections, 's'));
	
	$op_change = array(
			'article_bind_theme' => strstr($perm_articles, 'A'),
			'article_bind_lang'  => strstr($perm_articles, 'A'),
			'page_bind_lang'     => strstr($perm_articles, 'A'),
			'section_bind_lang'  => strstr($perm_sections, 'S'));
	
	echo '<form class="pme-form" method="post">',"\n";

	if (isset($_POST['article_bind_theme'])) {
		$type = 'article_bind_theme';
	} elseif (isset($_POST['article_bind_lang'])) {
		$type = 'article_bind_lang';
	} elseif (isset($_POST['page_bind_lang'])) {
		$type = 'page_bind_lang';
	} elseif (isset($_POST['section_bind_lang'])) {
		$type = 'section_bind_lang';
	} else {
		$action = '';
		isset($_POST['bind_remove']) && $action = 'remove';
		isset($_POST['bind_create']) && $action = 'create';
		$type = (string) @$_POST['type'];
		if ($op_change[$type] && strlen($type) > 0 && strlen($action) > 0) {
			// save action goes here
			ezin_admin_bindings_save($type, $action);
		}
	}

	if (strlen($type) <= 0) {
		$op_list['article_bind_theme'] && $type = 'article_bind_theme';
		is_array($ezin_cfg['languages']) && $op_list['section_bind_lang'] && $type = 'section_bind_lang';
	}

	if (! $op_list[$type]) {
		require 'inc-html/permdenied.html';
		return false;
	}

	if (stristr($ezin_cfg['admin_buttons_pos'], 'U')) {
		ezin_admin_bindings_buttons(is_array($ezin_cfg['languages']),
				$op_change[$type], $type, $op_list);
		echo '<hr class="pme-hr">',"\n";
	}

	switch ($type) {
		case 'article_bind_theme':
			$query = 'SELECT a.title AS name, a.atitle AS name2, a.access_key AS name3,'
				.' a.id, s.lang, a.bind_theme AS bind FROM '
				.$ezin_sys['db']['tables']['articles'].' AS a, '
				.$ezin_sys['db']['tables']['sections'].' AS s'
				.' WHERE a.section_id = s.id'
				.' ORDER BY IFNULL(bind,0) ASC, a.datetime DESC, a.id ASC';
			break;
		case 'article_bind_lang':
			$query = 'SELECT a.title AS name, a.atitle AS name2, a.access_key AS name3,'
				.' a.id, s.lang, a.bind_lang AS bind FROM '
				.$ezin_sys['db']['tables']['articles'].' AS a, '
				.$ezin_sys['db']['tables']['sections'].' AS s'
				.' WHERE a.section_id = s.id'
				.' AND UNIX_TIMESTAMP(datetime) != 0'
				.' ORDER BY IFNULL(bind,0) ASC, a.datetime DESC, a.id ASC';
			break;
		case 'page_bind_lang':
			$query = 'SELECT a.title AS name, a.atitle AS name2, a.access_key AS name3,'
				.' a.id, s.lang, a.bind_lang AS bind FROM '
				.$ezin_sys['db']['tables']['articles'].' AS a, '
				.$ezin_sys['db']['tables']['sections'].' AS s'
				.' WHERE a.section_id = s.id'
				.' AND (datetime IS NULL OR UNIX_TIMESTAMP(datetime) = 0)'
				.' ORDER BY IFNULL(bind,0) ASC, s.ord ASC, s.id ASC, a.id ASC';
			break;
		case 'section_bind_lang':
			$query = 'SELECT name, ord, access_key AS name2, link AS name3,'
				.' id, lang, bind_lang AS bind'
				.' FROM '.$ezin_sys['db']['tables']['sections']
				.' ORDER BY IFNULL(bind,0) ASC, ord ASC, id ASC';
			break;
		default:
			return false;
	}

	$result = @mysql_query($query, $ezin_db_handle);
	if ($result == false) {
		echo '<strong>mysql_query() error</strong>';
		echo '<hr>'.htmlspecialchars($query);
		return false;
	}

	echo '<table class="pme-main">',"\n";

	if (mysql_num_rows($result) == 0) {
		echo '<tr><td>No records in database.</td></tr>';
	}

	$lang_printing = $type != 'article_bind_theme';
	$bind_previous = -1;

	$i = 0;
	while (($row = mysql_fetch_array($result, MYSQL_ASSOC)) != false) {
		$name = $row['name'];
		empty($name) && $name = $row['name2'];
		empty($name) && $name = $row['name3'];
		$ord  = intval($row['ord']);
		$bind = intval($row['bind']);
		$lang = empty($row['lang']) ? '--' : $row['lang'];
		if ($bind_previous != $bind) {
			if ($bind_previous != -1) {
				echo '</table>',"\n";
				echo '<table class="pme-main">',"\n";
			}
			$colspan = 2;
			$lang_printing    && $colspan++;
			$op_change[$type] && $colspan++;
			echo '<tr class="pme-header">',"\n";
			echo '<th colspan=',$colspan,' class="pme-header">',"\n";
			if ($bind) {
				echo 'Binding ID ',$bind;
				if ($op_change[$type]) {
					echo ' <input class="pme-header" type="checkbox" name="binding[]" value="',$bind,'">';
				}
			} else {
				echo 'Unbinded';
			}
			echo '</td></tr>',"\n";
			$bind_previous = $bind;
		}
		echo '<tr class="pme-row-',$i,'">';
		if ($op_change[$type]) {
			echo '<td width="10" class="pme-navigation-',$i,'">',"\n";
			echo '<input type="checkbox" name="record[]" value="',$row['id'],'">';
			echo '</td>',"\n";
		}
		if ($lang_printing) {
			echo '<td width="10" class="pme-cell-',$i,'" width="1%" nowrap>&nbsp;';
			echo htmlspecialchars($lang),'&nbsp;</td>',"\n";
		}
		echo '<td width="10" class="pme-cell-',$i,'" width="1%" nowrap>&nbsp;';
		echo '<a href="',ezin_get_link((strncasecmp($type,'section', 7)?'A':'S'), $row['id']),'">';
		echo $row['id'],'</a>&nbsp;</td>',"\n";
		echo '<td class="pme-cell-',$i,'">',htmlspecialchars($name),'</td>',"\n";
		echo '</tr>',"\n";
		$i++;
		$i &= 1;
	}

	echo '</table>',"\n";

	@mysql_free_result($result);
	
	if (stristr($ezin_cfg['admin_buttons_pos'], 'D')
			|| ! stristr($ezin_cfg['admin_buttons_pos'], 'U')) {
		echo '<hr class="pme-hr">',"\n";
		ezin_admin_bindings_buttons(is_array($ezin_cfg['languages']),
				$op_change[$type], $type, $op_list);
	}
	echo '<input type="hidden" name="type" value="',$type,'">';
	echo '</form>',"\n";

	return;
} /* }}} */

function ezin_admin_bindings_buttons($f_multilng, $f_change, $type, $op_list) /* {{{ */
{
	echo '<table class="pme-navigation">',"\n";
	echo '<tr class="pme-navigation"><td class="pme-buttons">',"\n";
	$d = $f_multilng ? '' : ' disabled';
	$op_list['section_bind_lang'] && print('<input'.$d.' class="pme-sections" type="submit" name="section_bind_lang" value="Sections">&nbsp;');
	$op_list['article_bind_lang'] && print('<input'.$d.' class="pme-articles" type="submit" name="article_bind_lang" value="Articles">&nbsp;');
	$op_list['article_bind_lang'] && print('<input'.$d.' class="pme-pages" type="submit" name="page_bind_lang" value="Pages">&nbsp;');
	$op_list['article_bind_lang'] && print('<input'.   ' class="pme-themes" type="submit" name="article_bind_theme" value="Themes">');
	echo '</td>',"\n",'<td class="pme-buttons2">',"\n";
	// $f_change = 1; // DEBUG
	$d = $f_change ? '' : ' disabled';
	echo '<input'.$d.' class="pme-bind"   type="submit" name="bind_create" value="Bind">&nbsp;';
	echo '<input'.$d.' class="pme-unbind" type="submit" name="bind_remove" value="Unbind">';
	echo '</td></tr></table>',"\n";
} /* }}} */

function ezin_admin_bindings_save($type, $action) /* {{{ */
{
	global $ezin_sys;
	global $ezin_db_handle;
	global $ezin_admin_bindings_triggers;
	
	$ar_rec  = @$_POST['record'];
	$ar_bind = @$_POST['binding'];
	is_array($ar_rec)  || $ar_rec  = array();
	is_array($ar_bind) || $ar_bind = array();
	for ($i = 0; $i < count($ar_rec); $i++) {
		if (($ar_rec[$i] = intval($ar_rec[$i])) == 0)
			unset($ar_rec[$i]);
	}
	for ($i = 0; $i < count($ar_bind); $i++) {
		if (($ar_bind[$i] = intval($ar_bind[$i])) == 0)
			unset($ar_bind[$i]);
	}
	if (count($ar_rec) + count($ar_bind) <= 0)
		return false;

	$update_value = 0;
	$update_field = $type == 'article_bind_theme' ? 'bind_theme' : 'bind_lang';
	$update_table = $type == 'section_bind_lang'
		? $ezin_sys['db']['tables']['sections']
		: $ezin_sys['db']['tables']['articles'];
	if ($action == 'create') {
		if (count($ar_bind) > 0) {
			sort($ar_bind);
			$update_value = intval($ar_bind[0]);
		}
		if (! $update_value) {
			//$update_value = "MAX($update_field) + 1";
			$query = sprintf('SELECT MAX(IFNULL(%s, 0)) + 1 FROM %s',
					$update_field, $update_table);
			if ($result = @mysql_query($query, $ezin_db_handle)) {
				$row = @mysql_fetch_array($result, MYSQL_NUM);
				@mysql_free_result($result);
				$update_value = $row[0];
			}
		}
		if (! $update_value) {
			return false;
		}
	}
	
	$query = sprintf('UPDATE %s SET %s = %s',
		   $update_table, $update_field, $update_value);
	$query_add = '';
	if (count($ar_rec)  > 0) {
		$query_add .= 'id IN ('.join(', ', $ar_rec).')'; // )
	}
	if (count($ar_bind) > 0) {
		$query_add != '' && $query_add .=' OR ';
		$query_add .= $update_field.' IN ('.join(', ', $ar_bind).')'; // )
	}
	$query_add != '' && $query .=' WHERE '.$query_add;

	if (0) { // DEBUG
		echo 'type = '.$type.'<br>';
		echo 'action = '.$action.'<br>';
		echo 'update_table = '.$update_table.'<br>';
		echo 'update_field = '.$update_field.'<br>';
		echo 'update_value = '.$update_value.'<br>';
		echo 'query<hr>'.htmlspecialchars($query).'<hr>';
	}
	if (file_exists($ezin_admin_bindings_triggers['before'])) {
		$trigger_ret = include $ezin_admin_bindings_triggers['before'];
		if ($trigger_ret == false) {
			return -1;
		}
	}
	if (@mysql_query($query, $ezin_db_handle) == false) {
		return false;
	}
	if (file_exists($ezin_admin_bindings_triggers['after'])) {
		$trigger_ret = include $ezin_admin_bindings_triggers['after'];
		if ($trigger_ret == false) {
			return false;
		}
	}
	return true;
} /* }}} */

/*
 * main stuff
 */

$ezin_perm_articles = '';
$ezin_perm_sections = '';
ezin_admin_check_full_list_privileges($ezin_user['role_articles']) && $ezin_perm_articles .= 'a';
ezin_admin_check_full_list_privileges($ezin_user['role_sections']) && $ezin_perm_sections .= 's';
strstr($ezin_perm_articles, 'a') && stristr($ezin_user['role_articles'], 'C') && $ezin_perm_articles .= 'A';
strstr($ezin_perm_sections, 's') && stristr($ezin_user['role_sections'], 'C') && $ezin_perm_sections .= 'S';

if (strlen($ezin_perm_articles) > 0 || strlen($ezin_perm_sections) > 0) {
	ezin_check_db_handle();
	ezin_admin_bindings_main($ezin_perm_articles, $ezin_perm_sections);
	ezin_close_db_connection();
} else {
	require 'inc-html/permdenied.html';
}

/* Modeline for ViM {{{
 * vim: set ts=4:
 * vim600: fdm=marker fdl=0 fdc=0:
 * }}} */

?>
