<?php

/*
 * Metafox - enterprise content management system
 *
 * admin/inc/functions.inc.php - admin functions definitions
 * ____________________________________________________________
 *
 * Developed by Ondrej Jombik <nepto@platon.sk>
 * Copyright (c) 2001-2008 Platon Group, http://platon.sk/
 * All rights reserved.
 *
 * See README file for more information about this software.
 * See COPYING file for license information.
 *
 * Download the latest version from
 * http://platon.sk/projects/Metafox/
 */

/* $Platon: Metafox/admin/inc/functions.inc.php,v 1.9 2007-11-12 16:12:58 nepto Exp $ */

/* MAINTAINANCE: This file is maintained in Metafox project and distributed
   across the particular projects accordingly. */

function ezin_admin_check_list_privileges($priv) /* {{{ */
{
	return stristr($priv, 'L') !== false;
} /* }}} */

function ezin_admin_check_full_list_privileges($priv) /* {{{ */
{
	return strstr($priv, 'L') !== false;
} /* }}} */

function ezin_admin_check_restricted_list_privileges($priv) /* {{{ */
{
	return strstr($priv, 'l') !== false;
} /* }}} */

function ezin_admin_word_clean($content) /* {{{ */
{
	global $ezin_sys, $ezin_cfg;
	$content = preg_replace('|\&nbsp;|mi', ' ', $content);
	$content = preg_replace('|<!--\s+[^>]*\s+-->|mi', '', $content);
	$content = preg_replace('|<!doctype[^>]*>|mi', '', $content);
	$content = preg_replace('|<\?xml[^>]*>|mi', '', $content);
	$content = preg_replace('|<html[^>]*>|mi', '', $content);
	$content = preg_replace('|</html[^>]*>|mi', '', $content);
	$content = preg_replace('|<head[^>]*>|mi', '', $content);
	$content = preg_replace('|</head[^>]*>|mi', '', $content);
	$content = preg_replace('|<meta[^>]*>|mi', '', $content);
	$content = preg_replace('|</meta[^>]*>|mi', '', $content);
	$content = preg_replace('|<body[^>]*>|mi', '', $content);
	$content = preg_replace('|</body[^>]*>|mi', '', $content);
	$content = preg_replace('|<tbody[^>]*>|mi', '', $content);
	$content = preg_replace('|</tbody[^>]*>|mi', '', $content);
	$content = preg_replace('|<font[^>]*>|mi', '', $content);
	$content = preg_replace('|</font[^>]*>|mi', '', $content);
	$content = preg_replace('|<span[^>]*>|mi', '', $content);
	$content = preg_replace('|</span[^>]*>|mi', '', $content);
	$content = preg_replace('|<div[^>]*>|mi', '<p>', $content);
	$content = preg_replace('|</div[^>]*>|mi', '', $content);
	$content = preg_replace('|<o:[^>]*>|mi', '', $content);
	$content = preg_replace('|</o:[^>]*>|mi', '', $content);
	$content = preg_replace('|</p[^>]*>|mi', '', $content);
	$content = preg_replace('{<b(\s+[^>]*|)>}mi', '<b>', $content);
	$content = preg_replace('{<i(\s+[^>]*|)>}mi', '<i>', $content);
	$content = preg_replace('{<u(\s+[^>]*|)>}mi', '<u>', $content);
	$content = preg_replace('{</b(\s+[^>]*|)>}mi', '</b>', $content);
	$content = preg_replace('{</i(\s+[^>]*|)>}mi', '</i>', $content);
	$content = preg_replace('{</u(\s+[^>]*|)>}mi', '</u>', $content);
	//$content = preg_replace('|[\x0a]|mi', '~', $content); // TODO: fix this, not working

	$content = preg_replace('|\s*</table[^>]*>\s*|mi', "\n</table>", $content);
	$content = preg_replace('|\s*</tr[^>]*>\s*|mi', "\n</tr>", $content);
	$content = preg_replace('|\s*</th[^>]*>\s*|mi', "\n</th>", $content);
	$content = preg_replace('|\s*</td[^>]*>\s*|mi', "\n</td>", $content);
	$content = preg_replace('|\s*<table[^>]*>\s*|mi', "\n<table border=\"1\">", $content);
	$content = preg_replace('|\s*<tr[^>]*>\s*|mi', "\n<tr class=\"row\">", $content);
	$content = preg_replace('|\s*<th[^>]*>\s*|mi', "\n<th class=\"head\">", $content);
	$content = preg_replace('|\s*<td[^>]*>\s*|mi', "\n<td class=\"cell\">", $content);

	$content = preg_replace('|\s*</([^>]*)>\s*<\1>\s*|mi', '', $content); // ex: </i> <i>
	$content = preg_replace('|\s*<([^>]*)>\s*</\1>\s*|mi', '', $content); // ex: <STYLE></STYLE>
	$content = preg_replace('|\s*</([^>]*)>\s*<\1>\s*|mi', '', $content); // ex: </i> <i>
	$content = preg_replace('|\s*<([^>]*)>\s*</\1>\s*|mi', '', $content); // ex: <STYLE></STYLE>
	$content = preg_replace('|[ \t]+|mi', ' ', $content);
	$content = preg_replace('|\s*<p[^>]*>\s*|mi', "\n\r\n\r", $content);
	
	$content = trim($content);
	$tag = sprintf("<!--\n\tMS-Word cleaned by %s/%s\n\tat localtime %s\n-->\n",
			$ezin_sys['software']['name'], $ezin_sys['software']['version'],
			date($ezin_cfg['format_datetime']));
	return $tag.$content;
} /* }}} */

function ezin_admin_get_template_keys($template_name) /* {{{ */
{
	global $ezin_sys, $ezin_cfg;
	$output_ar  = array();
	$directory = dir($ezin_sys['dir']['root'].'/'.$ezin_sys['dir']['themes'].'/'.$ezin_cfg['theme']['name'].'/');
	$template_name .= $ezin_sys['tmpl']['delim'];
	$template_name_len = strlen($template_name);
	$delimext = $ezin_sys['tmpl']['delimext'];
	$delimext_len = strlen($delimext);
	while ($entry = $directory->read()) {
		if (strncmp($entry, $template_name, $template_name_len)) {
			continue;
		}
		$entry = Platon::str_replace_prefix($template_name, '', $entry);
		if (strncmp(strrev($entry), strrev($delimext), $delimext_len)) {
			continue;
		}
		$entry = Platon::str_replace_postfix($delimext, '', $entry);
		array_push($output_ar, $entry);
	}
	sort($output_ar);
	return $output_ar;
} /* }}} */

function ezin_admin_is_blog() /* {{{ */
{
	global $ezin_user;
	if (strpos($ezin_user['role_authors'], 'X') !== false) {
		return true;
	}
	return false;
} /* }}} */

/* Modeline for ViM {{{
 * vim: set ts=4:
 * vim600: fdm=marker fdl=0 fdc=0:
 * }}} */

?>
