/*
 * AUTHORS and USERS merge
 *
 * DO NOT RUN THIS!!!
 */

CREATE TABLE ezin_persons (
	  `id` int(11) NOT NULL auto_increment,
	  `old_user_id` int(11) default NULL,
	  `username` varchar(60) default NULL,
	  `password` varchar(60) default NULL,
	  `role_id` int(11) default NULL,
	  `type` enum('internal','external') default NULL,
	  `accesses_count` int(11) default NULL,
	  `sessions_count` int(11) default NULL,
	  `access_key` varchar(64) default NULL,
	  `template_key` varchar(64) default NULL,
	  `name` varchar(60) default NULL,
	  `email` varchar(60) default NULL,
	  `homepage` varchar(150) default NULL,
	  `description` text,
	  `description_flags` varchar(10) default NULL,
	  `description_wordcount` int(11) default NULL,
	default_section_id int(11) default NULL,
	  PRIMARY KEY  (`id`),
	  UNIQUE KEY `ezin_users_username` (`username`),
	  KEY `ezin_users_role_id` (`role_id`)
);

insert into ezin_persons
SELECT
a.id                   ,
u.id                   ,
u.username             ,
u.password             ,
u.role_id              ,
a.type                 ,
a.accesses_count       ,
a.sessions_count       ,
a.access_key           ,
a.template_key         ,
a.name                 ,
a.email                ,
a.homepage             ,
a.description          ,
a.description_flags    ,
a.description_wordcount,
NULL
from ezin_authors a join ezin_users u on a.id = u.author_id;

insert into ezin_persons
SELECT
a.id                   ,
u.id                   ,
u.username             ,
u.password             ,
u.role_id              ,
a.type                 ,
a.accesses_count       ,
a.sessions_count       ,
a.access_key           ,
a.template_key         ,
a.name                 ,
a.email                ,
a.homepage             ,
a.description          ,
a.description_flags    ,
a.description_wordcount,
NULL
from ezin_authors a left  join ezin_users u on a.id = u.author_id
where u.id is NULL;

insert into ezin_persons
SELECT
a.id                   ,
u.id                   ,
u.username             ,
u.password             ,
u.role_id              ,
a.type                 ,
a.accesses_count       ,
a.sessions_count       ,
a.access_key           ,
a.template_key         ,
a.name                 ,
a.email                ,
a.homepage             ,
a.description          ,
a.description_flags    ,
a.description_wordcount,
NULL
from ezin_authors a right join ezin_users u on a.id = u.author_id
where a.id is NULL;

alter table ezin_authors rename to ezin_authors_delete_me;
alter table ezin_users   rename to ezin_users_delete_me;

update ezin_persons set type = 'internal' where type is NULL or type = '';
update ezin_persons set name = CONCAT('PERSON #', id) where name is null or trim(name) = '';
update ezin_persons set accesses_count = 0 where accesses_count is null;
update ezin_persons set sessions_count = 0 where sessions_count is null;

